VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmAutoMapMaker 
   Caption         =   "Auto Map Maker"
   ClientHeight    =   7245
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   9870
   LinkTopic       =   "Form1"
   ScaleHeight     =   483
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   658
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cmdlgFile 
      Left            =   0
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DefaultExt      =   "lists"
      Filter          =   "Fitness lists (*.lists)|*.lists"
   End
   Begin VB.Frame fmeAutoGenerate 
      Caption         =   "Auto Generate"
      Height          =   2175
      Left            =   7800
      TabIndex        =   1
      Top             =   0
      Width           =   2055
      Begin VB.TextBox txtRandomNumberSeed 
         Height          =   285
         Left            =   120
         TabIndex        =   3
         Top             =   600
         Width           =   1710
      End
      Begin VB.CommandButton cmdGenerate 
         Caption         =   "&Generate"
         Default         =   -1  'True
         Height          =   375
         Left            =   120
         TabIndex        =   7
         Top             =   1680
         Width           =   1815
      End
      Begin VB.PictureBox picSeedTile 
         Height          =   540
         Left            =   1320
         ScaleHeight     =   32
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   32
         TabIndex        =   6
         Top             =   1080
         Width           =   540
      End
      Begin VB.TextBox txtSeedTileIndex 
         Height          =   285
         Left            =   120
         TabIndex        =   5
         Text            =   "1"
         Top             =   1320
         Width           =   1095
      End
      Begin VB.Label lblRandomNumberSeed 
         Caption         =   "Random number seed"
         Height          =   195
         Left            =   120
         TabIndex        =   2
         Top             =   360
         Width           =   1560
      End
      Begin VB.Label lblSeedTileIndex 
         Caption         =   "Seed Tile Index"
         Height          =   195
         Left            =   120
         TabIndex        =   4
         Top             =   1080
         Width           =   1110
      End
   End
   Begin MSComctlLib.StatusBar stbStatus 
      Align           =   2  'Align Bottom
      Height          =   255
      Left            =   0
      TabIndex        =   12
      Top             =   6990
      Width           =   9870
      _ExtentX        =   17410
      _ExtentY        =   450
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   2
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
         BeginProperty Panel2 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   1
            Object.Width           =   14314
            MinWidth        =   5292
         EndProperty
      EndProperty
   End
   Begin VB.Frame fmeAdjacencyDetails 
      Caption         =   "Adjacency Details"
      Height          =   4815
      Left            =   7800
      TabIndex        =   8
      Top             =   2160
      Width           =   2055
      Begin VB.CommandButton cmdDelete 
         Caption         =   "Delete"
         Height          =   375
         Left            =   240
         TabIndex        =   13
         Top             =   2640
         Width           =   1575
      End
      Begin VB.ComboBox cmbListSelect 
         Height          =   315
         Left            =   240
         Style           =   2  'Dropdown List
         TabIndex        =   11
         Top             =   2160
         Width           =   1575
      End
      Begin VB.PictureBox picSelectedTile 
         Height          =   1575
         Left            =   240
         ScaleHeight     =   101
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   101
         TabIndex        =   10
         Top             =   480
         Width           =   1575
      End
      Begin VB.Label lblSelectedTile 
         Caption         =   "Selected tile details"
         Height          =   195
         Left            =   240
         TabIndex        =   9
         Top             =   240
         Width           =   1365
      End
   End
   Begin VB.PictureBox picMap 
      ForeColor       =   &H8000000E&
      Height          =   6975
      Left            =   0
      ScaleHeight     =   461
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   509
      TabIndex        =   0
      Top             =   0
      Width           =   7695
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &as"
      End
      Begin VB.Menu mnuFileSperator 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmAutoMapMaker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Global resource manager
Private resMan As New ResourceManager

' Global variables used to generate a new map
Private newMap As MapFile               ' Holds the new map being generated
Private tileSel As New CTileSelector    ' Holds fitness data used to select new tiles
Private fitnessFile As String           ' Holds the filename of the file containing fitness data

' Global variables used to display the map
Private scrollX As Long
Private scrollY As Long

' Global variables relating to the selected tile
Private selectedX As Long
Private selectedY As Long
Private selectedTile As Long
Private selectedTopTile As Long
Private selectedLeftTile As Long
Private selectedRightTile As Long
Private selectedBottomTile As Long


Private Sub cmbListSelect_Change()
    Dim adjacentTile As Long
    Dim i As Long
    Dim list As CFitnessList

    ' Check if a center tile was selected
    If selectedTile = -1 Then Exit Sub
    
    ' Make sure an item is selected
    If cmbListSelect.ListIndex = -1 Then Exit Sub
    
    ' Determine the index of the adjacent tile (according to item selected)
    Select Case cmbListSelect.ListIndex
        Case 0      ' Top
            adjacentTile = selectedTopTile
        Case 1      ' Left
            adjacentTile = selectedLeftTile
        Case 2      ' Right
            adjacentTile = selectedRightTile
        Case 3      ' Bottom
            adjacentTile = selectedBottomTile
    End Select
    
    
    ' Get the selected adjacency list
    Set list = tileSel.FitnessList(selectedTile, cmbListSelect.ListIndex)
    ' Display the adjacency list
    For i = 0 To list.Size - 1
        ' Check if the current item is the adjacent one
    Next i
End Sub

Private Sub cmdDelete_Click()
    Dim tile2 As Long

    ' Make sure a tile is selected
    If selectedTile < 0 Then Exit Sub
    
    ' Make sure a direction is selected
    If cmbListSelect.ListIndex = -1 Then Exit Sub
    
    ' Perform a symmetric delete of these two tiles from each other's lists
    Select Case cmbListSelect.ListIndex
        Case 0      ' Top
            tile2 = selectedTopTile
        Case 1      ' Left
            tile2 = selectedLeftTile
        Case 2      ' Right
            tile2 = selectedRightTile
        Case 3      ' Bottom
            tile2 = selectedBottomTile
    End Select
    
    ' Perform the delete
    SymmetricDelete selectedTile, tile2, cmbListSelect.ListIndex
End Sub

Private Sub SymmetricDelete(tile1 As Long, tile2 As Long, dir As Long)
    ' Delete tile2 from tile1's list in the given direction
    tileSel.FitnessList(tile1, dir).RemoveTile tile2
    
    ' Delete tile1 from tile2's list in the given direction
    tileSel.FitnessList(tile2, 3 - dir).RemoveTile tile1
End Sub

Private Sub cmdGenerate_Click()
    ' Display status info
    stbStatus.Panels(2).Text = "Generating new map..."
    
    ' Generate new map data
    GenerateMap
    
    ' Display the results
    picMap_Paint

    ' Update status info
    stbStatus.Panels(2).Text = ""
End Sub

Private Sub Form_Load()
    Dim volFile As ArchiveReader
    
    ' Initialize tiles to unselected
    selectedTile = -1
    selectedTopTile = -1
    selectedLeftTile = -1
    selectedRightTile = -1
    selectedBottomTile = -1

    ' Load the tile fitness data
    fitnessFile = App.Path & "\fitness.lists"
    tileSel.LoadFitnessData fitnessFile
    
    
    ' **TODO** Remove this cheap debug hack
    resMan.RootPath = "\Sierra\Outpost2\"

    ' Load the maps VOL file
    Set volFile = resMan.LoadVolFile("maps.vol", True)
    ' Allow resources to be loaded from this VOL file
    resMan.AddArchiveToSearch volFile
    ' We no longer need the handle to the VOL file
    Set volFile = Nothing

    ' Create a default new blank map
    CreateNewMapObject
    
    ' Populate the ListSelect combo box
    cmbListSelect.AddItem "Top list"
    cmbListSelect.AddItem "Left list"
    cmbListSelect.AddItem "Right list"
    cmbListSelect.AddItem "Bottom list"
    
    ' Choose an initial random number seed
    txtRandomNumberSeed.Text = Format$(Timer)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Cleanup and exit
    
    ' Release the new map
    Set newMap = Nothing
    
    ' Release the global resource manager
    Set resMan = Nothing
End Sub

Private Sub Form_Resize()
    ' Abort if minimized
    If Me.ScaleWidth = 0 Or Me.ScaleHeight = 0 Then Exit Sub
    
    ' Set a minimum size
    If Me.Width < 5000 Then Me.Width = 5000
    If Me.Height < 5200 Then Me.Height = 5200

    ' Resize the status bar
    stbStatus.Move 0, ScaleHeight - stbStatus.Height, ScaleWidth, stbStatus.Height
    ' Resize the Auto Generate frame
    fmeAutoGenerate.Move ScaleWidth - fmeAutoGenerate.Width
    ' Resize the Adjacency details frame
    fmeAdjacencyDetails.Move ScaleWidth - fmeAdjacencyDetails.Width, fmeAutoGenerate.Top + fmeAutoGenerate.Height, fmeAdjacencyDetails.Width, stbStatus.Top - fmeAdjacencyDetails.Top
    ' Resize the picture box
    picMap.Move 0, 0, fmeAutoGenerate.Left, stbStatus.Top - picMap.Top
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuFileOpen_Click()
    ' Display the open dialog box
    cmdlgFile.ShowOpen
    
    ' Check for cancel
    If Len(cmdlgFile.FileName) = 0 Then
        ' Action was cancelled
        Exit Sub
    End If
    
    fitnessFile = cmdlgFile.FileName
    tileSel.LoadFitnessData fitnessFile
    
    ' Update the status
    stbStatus.Panels(2).Text = "Loaded fitness file " + fitnessFile
End Sub

Private Sub mnuFileSave_Click()
    ' Check for a default save file
    If Len(fitnessFile) <> 0 Then
        ' Save the file
        tileSel.SaveFitnessData fitnessFile
        
        ' Update the status
        stbStatus.Panels(2).Text = "Saved to file " + fitnessFile
    Else
        ' No default file. Use Save_As
        mnuFileSaveAs_Click
    End If
End Sub

Private Sub mnuFileSaveAs_Click()
    ' Display the save dialog box
    cmdlgFile.ShowSave
    
    ' Check for cancel
    If Len(cmdlgFile.FileName) = 0 Then
        ' Action was cancelled
        Exit Sub
    End If

     ' Get the save file name
    fitnessFile = cmdlgFile.FileName
    tileSel.SaveFitnessData fitnessFile
    
    ' Update the status
    stbStatus.Panels(2).Text = "Saved to file " + fitnessFile
End Sub

Private Sub picMap_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim tileX As Long, tileY As Long

    ' Make sure a map has been generated
    If newMap Is Nothing Then Exit Sub
    
    ' Determine which tile was clicked on
    tileX = (X + scrollX) \ 32
    tileY = (Y + scrollY) \ 32

    ' Store the selected coordinates
    selectedX = tileX
    selectedY = tileY

    ' Get selected tile index
    On Error Resume Next
    selectedTile = newMap.mappingIndex(tileX, tileY)
    If tileY > 0 Then selectedTopTile = newMap.mappingIndex(tileX, tileY - 1) Else selectedTopTile = -1
    If tileX > 0 Then selectedLeftTile = newMap.mappingIndex(tileX - 1, tileY) Else selectedLeftTile = -1
    If tileX < newMap.TileWidth - 1 Then selectedRightTile = newMap.mappingIndex(tileX + 1, tileY) Else selectedRightTile = -1
    If tileY < newMap.TileHeight - 1 Then selectedBottomTile = newMap.mappingIndex(tileX, tileY + 1) Else selectedBottomTile = -1
    On Error GoTo 0
    
    ' Update the selected tile view
    picMap_Paint
    picSelectedTile.Refresh
End Sub

Private Sub picMap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim tileX As Long, tileY As Long

    ' Make sure a map has been generated
    If newMap Is Nothing Then Exit Sub

    ' Determine which tile was clicked on
    tileX = (X + scrollX) \ 32
    tileY = (Y + scrollY) \ 32

    ' Update displayed position
    stbStatus.Panels(1).Text = "(" + Format$(tileX) + "," + Format$(tileY) + ")"
End Sub

Private Sub picMap_Paint()
    ' Make sure a map has been generated
    If newMap Is Nothing Then Exit Sub

    ' Draw the map to the picture box
    newMap.Draw picMap.hDC, scrollX, scrollY, picMap.ScaleWidth, picMap.ScaleHeight
    
    ' Check if any tiles are selected
    ' *******************************
    
    ' Top
    If selectedTopTile >= 0 Then
        ' Draw top border
        picMap.Line (selectedX * 32 - 1, selectedY * 32 - 33)-(selectedX * 32 + 33, selectedY * 32 - 33)
        ' Draw left border
        picMap.Line (selectedX * 32 - 1, selectedY * 32 - 33)-(selectedX * 32 - 1, selectedY * 32)
        ' Draw right border
        picMap.Line (selectedX * 32 + 32, selectedY * 32 - 33)-(selectedX * 32 + 32, selectedY * 32)
    ElseIf selectedTile >= 0 Then
        ' Draw top border of center tile
        picMap.Line (selectedX * 32 - 1, selectedY * 32 - 1)-(selectedX * 32 + 32, selectedY * 32 - 1)
    End If

    ' Left
    If selectedLeftTile >= 0 Then
        ' Draw left border
        picMap.Line (selectedX * 32 - 33, selectedY * 32 - 1)-(selectedX * 32 - 33, selectedY * 32 + 33)
        ' Draw top border
        picMap.Line (selectedX * 32 - 33, selectedY * 32 - 1)-(selectedX * 32, selectedY * 32 - 1)
        ' Draw bottom border
        picMap.Line (selectedX * 32 - 33, selectedY * 32 + 32)-(selectedX * 32, selectedY * 32 + 32)
    ElseIf selectedTile >= 0 Then
        ' Draw left border of center tile
        picMap.Line (selectedX * 32 - 1, selectedY * 32 - 1)-(selectedX * 32 - 1, selectedY * 32 + 32)
    End If

    ' Right
    If selectedRightTile >= 0 Then
        ' Draw right border
        picMap.Line (selectedX * 32 + 64, selectedY * 32 - 1)-(selectedX * 32 + 64, selectedY * 32 + 33)
        ' Draw top border
        picMap.Line (selectedX * 32 + 32, selectedY * 32 - 1)-(selectedX * 32 + 64, selectedY * 32 - 1)
        ' Draw bottom border
        picMap.Line (selectedX * 32 + 32, selectedY * 32 + 32)-(selectedX * 32 + 64, selectedY * 32 + 32)
    ElseIf selectedTile >= 0 Then
        ' Draw right border of center tile
        picMap.Line (selectedX * 32 + 32, selectedY * 32 - 1)-(selectedX * 32 + 32, selectedY * 32 + 32)
    End If

    ' Bottom
    If selectedBottomTile >= 0 Then
        ' Draw bottom border
        picMap.Line (selectedX * 32 - 1, selectedY * 32 + 64)-(selectedX * 32 + 33, selectedY * 32 + 64)
        ' Draw left border
        picMap.Line (selectedX * 32 - 1, selectedY * 32 + 32)-(selectedX * 32 - 1, selectedY * 32 + 64)
        ' Draw right border
        picMap.Line (selectedX * 32 + 32, selectedY * 32 + 32)-(selectedX * 32 + 32, selectedY * 32 + 64)
    ElseIf selectedTile >= 0 Then
        ' Draw bottom border of center tile
        picMap.Line (selectedX * 32 - 1, selectedY * 32 + 32)-(selectedX * 32 + 32, selectedY * 32 + 32)
    End If
End Sub



Private Sub txtSeedTileIndex_Change()
    Dim tileIndex As Long
    
    ' Bounds check the nubmer of tiles
    tileIndex = Val(txtSeedTileIndex.Text)
    If tileIndex >= newMap.TileSetManager.NumMappings Then
        ' Correct value to within range
        tileIndex = newMap.TileSetManager.NumMappings - 1
        txtSeedTileIndex.Text = Format$(tileIndex)
    End If
    
    picSeedTile_Paint
End Sub


Private Sub picSeedTile_Paint()
    Dim tileMan As TileSetManager
    Dim tileIndex As Long
    Dim tileSetIndex As Long
    Dim tileSetTileIndex As Long

    ' Make sure a map has been generated
    If newMap Is Nothing Then Exit Sub

    ' Make sure a valid tile was selected
    tileIndex = Val(txtSeedTileIndex.Text)
    If tileIndex < 0 Then Exit Sub

    ' Get access to the map's tile sets
    Set tileMan = newMap.TileSetManager
    
    ' Check if the index is out of range
    If tileIndex >= tileMan.NumMappings Then Exit Sub

    ' Get access to the right tile set
    tileSetIndex = tileMan.tileSetIndex(tileIndex)
    tileSetTileIndex = tileMan.tileSetTileIndex(tileIndex)
    tileMan.TileSet(tileSetIndex).PasteTile picSeedTile.hDC, 0, 0, 0, 0, 32, 32, tileSetTileIndex
    
    ' Release the tile set manager
    Set tileMan = Nothing
End Sub

Private Sub picSelectedTile_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim tileX As Long, tileY As Long

    ' Determine which tile was clicked on, relative to the center one
    tileX = Int((X - ((picSelectedTile.ScaleWidth - 32) \ 2)) / 32)
    tileY = Int((Y - ((picSelectedTile.ScaleHeight - 32) \ 2)) / 32)

    ' Check if the Top tile was clicked on
    If tileX = 0 And tileY = -1 And selectedTopTile <> -1 Then
        ' Top list selected
        cmbListSelect.ListIndex = 0
    End If
    
    ' Check if the Left tile was clicked on
    If tileX = -1 And tileY = 0 And selectedLeftTile <> -1 Then
        ' Left list selected
        cmbListSelect.ListIndex = 1
    End If
    
    ' Check if the Right tile was clicked on
    If tileX = 1 And tileY = 0 And selectedRightTile <> -1 Then
        ' Right list selected
        cmbListSelect.ListIndex = 2
    End If
    
    ' Check if the Bottom tile was clicked on
    If tileX = 0 And tileY = 1 And selectedBottomTile <> -1 Then
        ' Bottom list selected
        cmbListSelect.ListIndex = 3
    End If
End Sub

Private Sub picSelectedTile_Paint()
    ' Display the selected tiles (if any)
    
    ' Make sure a map has been generated
    If newMap Is Nothing Then Exit Sub
    
    ' Center
    DisplaySelectedTile (picSelectedTile.ScaleWidth - 32) \ 2, (picSelectedTile.ScaleHeight - 32) \ 2, selectedTile
    ' Top
    DisplaySelectedTile (picSelectedTile.ScaleWidth - 32) \ 2, (picSelectedTile.ScaleHeight - 32) \ 2 - 32, selectedTopTile
    ' Left
    DisplaySelectedTile (picSelectedTile.ScaleWidth - 32) \ 2 - 32, (picSelectedTile.ScaleHeight - 32) \ 2, selectedLeftTile
    ' Right
    DisplaySelectedTile (picSelectedTile.ScaleWidth - 32) \ 2 + 32, (picSelectedTile.ScaleHeight - 32) \ 2, selectedRightTile
    ' Bottom
    DisplaySelectedTile (picSelectedTile.ScaleWidth - 32) \ 2, (picSelectedTile.ScaleHeight - 32) \ 2 + 32, selectedBottomTile
End Sub


Private Sub DisplaySelectedTile(pixelX As Long, pixelY As Long, tileIndex As Long)
    Dim tileMan As TileSetManager
    Dim tileSetIndex As Long
    Dim tileSetTileIndex As Long
    
    ' Make sure a valid tile was selected
    If tileIndex < 0 Then Exit Sub
        
    ' Get access to the map's tile sets
    Set tileMan = newMap.TileSetManager

    ' Get access to the right tile set
    tileSetIndex = tileMan.tileSetIndex(tileIndex)
    tileSetTileIndex = tileMan.tileSetTileIndex(tileIndex)
    tileMan.TileSet(tileSetIndex).PasteTile picSelectedTile.hDC, pixelX, pixelY, 0, 0, 32, 32, tileSetTileIndex
    
    ' Release the tile set manager
    Set tileMan = Nothing
End Sub

Private Sub CreateNewMapObject()
    ' Create a new blank map
    Set newMap = resMan.CreateNewMap(32, 32)
    'Set newMap = resMan.CreateNewMap(1024, 1024)

    ' Add the default tile sets to it
    ' *******************************
    
    Dim tileMan As TileSetManager
    Dim loadedTileSet As TileSet
    Dim i As Long
    Dim index As Long
    Dim numLoadedTiles As Long

    ' Get access to the tile set manager
    Set tileMan = newMap.TileSetManager()
    ' Load and process all tile sets
    For i = 0 To 12
        ' Load the tile set into the map file
        index = tileMan.AddTileSet("well00" + Format$(i, "00"))
        
        ' Get a reference to the loaded tile set
        Set loadedTileSet = tileMan.TileSet(index)
        ' Get the number of tiles in the loaded tile set
        numLoadedTiles = loadedTileSet.numTiles
        ' Release the reference to the loaded tile set
        Set loadedTileSet = Nothing
        
        ' Map in all the tiles in the tile set
        tileMan.MapInTiles index, 0, numLoadedTiles
    Next i

    ' Release reference to the tile set manager
    Set tileMan = Nothing

    ' Clear the map
    Dim X As Long, Y As Long
    For Y = 0 To newMap.TileHeight - 1
        For X = 0 To newMap.TileWidth - 1
            newMap.mappingIndex(X, Y) = 0
        Next X
    Next Y
End Sub


Private Sub GenerateMap()
    ' Initialize random number generator
    Rnd -1
    Randomize Val(txtRandomNumberSeed.Text)
    
    ' Clear the map
    Dim X As Long, Y As Long
    For Y = 0 To newMap.TileHeight - 1
        For X = 0 To newMap.TileWidth - 1
            newMap.mappingIndex(X, Y) = 0
        Next X
    Next Y
    
    ' Choose an initial seed tile
    On Error Resume Next
    newMap.mappingIndex(0, 0) = Val(txtSeedTileIndex.Text)
    On Error GoTo 0
    ' Fill in all the map holes
    FillMapHoles
    
    
    ' **DEBUG**
    ' Save the map
    'Dim outFile As StreamWriter
    'Set outFile = resMan.OpenStreamWrite("NewMap.map")
    'newMap.SaveMap outFile, MapOnly
End Sub

Private Sub FillMapHoles()
    Dim mapWidth As Long, mapHeight As Long
    Dim X As Long, Y As Long
    Dim topTile As Long, leftTile As Long, rightTile As Long, bottomTile As Long
    Dim newTile As Long

    ' Get the map dimensions
    mapWidth = newMap.TileWidth
    mapHeight = newMap.TileHeight

    ' Generate tiles for the whole map
    For Y = 0 To mapHeight - 1
        For X = 0 To mapWidth - 1
            ' Check if this location doesn't currently have a tile
            If newMap.mappingIndex(X, Y) = 0 Then
                ' Get the surrounding tiles
                If Y > 0 Then topTile = newMap.mappingIndex(X, Y - 1) Else topTile = 0
                If X > 0 Then leftTile = newMap.mappingIndex(X - 1, Y) Else leftTile = 0
                If X < mapWidth - 1 Then rightTile = newMap.mappingIndex(X + 1, Y) Else rightTile = 0
                If Y < mapHeight - 1 Then bottomTile = newMap.mappingIndex(X, Y + 1) Else bottomTile = 0

                ' Generate a new tile for location (x,y)
                newTile = tileSel.ChooseTile(topTile, leftTile, rightTile, bottomTile)
                
                ' Set the new tile
                newMap.mappingIndex(X, Y) = newTile
                
                ' Check if backtracking is needed
                If newTile = 0 Then
                    If X = 1 And Y = 0 Then Exit Sub    ' Failed!
                    If X > 0 And (Y = 0 Or Int(Rnd * 2) = 0) Then
                        X = X - 2
                        newMap.mappingIndex(X + 1, Y) = 0
                    ElseIf Y > 0 Then
                        Y = Y - 1
                        Dim i As Long
                        For i = X To mapWidth - 1
                            newMap.mappingIndex(i, Y) = 0
                        Next i
                        For i = 0 To X
                            newMap.mappingIndex(i, Y + 1) = 0
                        Next i
                        X = X - 1
                    End If
                End If
                If newTile > 2012 Then
                    Debug.Print "Range error:"; newTile
                End If
                
            End If
        Next X
    Next Y
End Sub
